searchNodes=[{"doc":"Integration with Auth0 to authorize m2m communication","ref":"BridgeEx.Auth0AuthorizationProvider.html","title":"BridgeEx.Auth0AuthorizationProvider","type":"module"},{"doc":"","ref":"BridgeEx.Auth0AuthorizationProvider.html#authorization_headers/1","title":"BridgeEx.Auth0AuthorizationProvider.authorization_headers/1","type":"function"},{"doc":"Main module to be used to implement graphql bridges. You need to provide an endpoint on use , e.g. use BridgeEx.Graphql , endpoint : &quot;https://your.auth0.endpoint&quot;","ref":"BridgeEx.Graphql.html","title":"BridgeEx.Graphql","type":"module"},{"doc":"Create a Graphql bridge in the given module. Once created, a graphql request can be made via MyBridge.call(&quot;my-query&quot;, %{&quot;variable&quot;: &quot;var&quot;}) Options endpoint (required): URL of the remote Graphql endpoint. auth0 : enable and configure Auth0 for authentication of requests. Takes the form of [enabled: false, audience: &quot;target-audience&quot;] . encode_variables : if true, encode the Graphql variables to JSON. Defaults to false . format_response : transforms camelCase keys in response to snake_case. Defaults to false . http_headers : HTTP headers for the request. Defaults to %{&quot;Content-type&quot;: &quot;application/json&quot;} http_options : HTTP options to be passed to Telepoison. Defaults to [timeout: 1_000, recv_timeout: 16_000] . log_options : override global configuration for logging errors. Takes the form of [log_query_on_error: false, log_response_on_error: false] max_attempts : number of times the request will be retried upon failure. Defaults to 1 . Examples defmodule MyBridge do use BridgeEx.Graphql , endpoint : &quot;http://my-api.com/graphql&quot; end defmodule MyBridge do use BridgeEx.Graphql , endpoint : &quot;http://my-api.com/graphql&quot; , auth0 : [ enabled : true , audience : &quot;target-audience&quot; ] end","ref":"BridgeEx.Graphql.html#__using__/1","title":"BridgeEx.Graphql.__using__/1","type":"macro"},{"doc":"Graphql client for BridgeEx.","ref":"BridgeEx.Graphql.Client.html","title":"BridgeEx.Graphql.Client","type":"module"},{"doc":"Calls a GraphQL endpoint Parameters url : URL of the endpoint. query : Graphql query or mutation. variables : dariables for Graphql query or mutation. http_options : HTTPoison options. http_headers : HTTPoison headers. max_attempts : defines number of retries before returning error. log_options : configures logging on errors. Takes the form of [log_query_on_error: false, log_response_on_error: false] .","ref":"BridgeEx.Graphql.Client.html#call/7","title":"BridgeEx.Graphql.Client.call/7","type":"function"},{"doc":"Formats a GraphQL query response to make it Absinthe compliant","ref":"BridgeEx.Graphql.Client.html#format_response/1","title":"BridgeEx.Graphql.Client.format_response/1","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Client.html#t:bridge_response/0","title":"BridgeEx.Graphql.Client.bridge_response/0","type":"type"},{"doc":"This defines an adapter that supports GraphQL query documents in their conventional (in JS) camelcase notation, while allowing the schema to be defined using conventional (in Elixir) underscore (snakecase) notation, and tranforming the names as needed for lookups, results, and error messages. For example, this document: { myUser : createUser ( userId : 2 ) { firstName lastName } } Would map to an internal schema that used the following names: create_user instead of createUser user_id instead of userId first_name instead of firstName last_name instead of lastName Likewise, the result of executing this (camelcase) query document against our (snakecase) schema would have its names transformed back into camelcase on the way out: %{ data : %{ &quot;myUser&quot; =&gt; %{ &quot;firstName&quot; =&gt; &quot;Joe&quot; , &quot;lastName&quot; =&gt; &quot;Black&quot; } } } Note variables are a client-facing concern (they may be provided as parameters), so variable names should match the convention of the query document (eg, camelCase).","ref":"BridgeEx.Graphql.LanguageConventions.html","title":"BridgeEx.Graphql.LanguageConventions","type":"module"},{"doc":"Callback implementation for Absinthe.Adapter.to_external_name/2 .","ref":"BridgeEx.Graphql.LanguageConventions.html#to_external_name/2","title":"BridgeEx.Graphql.LanguageConventions.to_external_name/2","type":"function"},{"doc":"Converts a camelCase to snake_case iex&gt; to_internal_name(&quot;test&quot;, :read) &quot;test&quot; iex&gt; to_internal_name(&quot;testTTT&quot;, :read) &quot;test_t_t_t&quot; iex&gt; to_internal_name(&quot;testTest&quot;, :read) &quot;test_test&quot; iex&gt; to_internal_name(&quot;testTest1&quot;, :read) &quot;test_test_1&quot; iex&gt; to_internal_name(&quot;testTest11&quot;, :read) &quot;test_test_11&quot; iex&gt; to_internal_name(&quot;testTest11Pippo&quot;, :read) &quot;test_test_11_pippo&quot; iex&gt; to_internal_name(&quot;camelCase23Snake4344&quot;, :read) &quot;camel_case_23_snake_4344&quot;","ref":"BridgeEx.Graphql.LanguageConventions.html#to_internal_name/2","title":"BridgeEx.Graphql.LanguageConventions.to_internal_name/2","type":"function"},{"doc":"Misc utils for handling Graphql requests/responses.","ref":"BridgeEx.Graphql.Utils.html","title":"BridgeEx.Graphql.Utils","type":"module"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#decode_http_response/3","title":"BridgeEx.Graphql.Utils.decode_http_response/3","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#normalize_inner_fields/1","title":"BridgeEx.Graphql.Utils.normalize_inner_fields/1","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#parse_response/1","title":"BridgeEx.Graphql.Utils.parse_response/1","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#retry/3","title":"BridgeEx.Graphql.Utils.retry/3","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#t:client_response/0","title":"BridgeEx.Graphql.Utils.client_response/0","type":"type"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#t:graphql_response/0","title":"BridgeEx.Graphql.Utils.graphql_response/0","type":"type"},{"doc":"Copyright (c) 2020 Prima.it Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"A library to build bridges to other services (actually only graphql ones are supported).","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Graphql Bridges to Graphql services are defined by use ing the BridgeEx.Graphql macro as follows: defmodule MyApp.SomeServiceBridge do use BridgeEx.Graphql , endpoint : &quot;http://some_service.example.com&quot; def my_query ( %{ } = variables ) do call ( &quot;a graphql query or mutation&quot; , variables ) end end Besides endpoint , the following parameters can be optionally set when use ing BridgeEx.Graphql : auth0 encode_variables format_response http_headers http_options log_options max_attempts Refer to the documentation for more details. If you need more control on your requests you can use BridgeEx.Graphql.Client.call directly. Global configuration The following configuration parameters can be set globally for all bridges in the app, by setting them inside your config.exs : config :bridge_ex, auth0_enabled: true to allow bridges to enable integration with Auth0 config :bridge_ex, log_options: [log_query_on_error: true, log_response_on_error: false] to customize logging in your bridges Authenticating calls via Auth0 bridge_ex supports authentication of machine-to-machine calls via Auth0, through the prima_auth0_ex library. To use this feature it is necessary to set the following configuration in your config.exs : auth0 support for the application in the environment must be enabled via config :bridge_ex, auth0_enabled: true . configuration necessary to create API consumers with prima_auth0_ex , see the documentation . Then configure your bridge with the audience of the target service: use BridgeEx.Graphql , endpoint : &quot;...&quot; , auth0 : [ enabled : true , audience : &quot;target_audience&quot; ] Note that Auth0 integration must be explicitly enabled for each bridge by setting auth0: [enable: true] , as per the example above.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"As a good practice, if you want to mock your bridge for testing, you should define a behaviour: defmodule MyApp.SomeService do @callback my_cool_query ( any ( ) ) :: { :ok , map ( ) } | { :error , any ( ) } end Then implement it for your bridge: defmodule MyApp.SomeServiceBridge do @behaviour MyApp.SomeService use BridgeEx.Graphql , endpoint : &quot;...&quot; And finally implement it again for the mock: defmodule MyApp.SomeServiceBridgeMock do @behaviour MyApp.SomeService alias BridgeEx.Graphql.Utils def my_cool_query ( %{ } = variables ) do File . read! ( &quot;some_mock_file.json&quot; ) |&gt; Json . decode! ( keys : :atoms ) |&gt; Utils . parse_response ( ) # required to parse data # |&gt; BridgeEx.Graphql.Client.format_response() # optional, if you want to format response end end You can now set the right module in your config/* directory: config :my_app , :some_service_bridge , MyApp.SomeServiceBridge # or config :my_app , :some_service_bridge , MyApp.SomeServiceBridgeMock And use it in your app from configuration: @some_service Application . compile_env! ( :my_app , :some_service_bridge ) # ... @some_service . my_cool_query ( %{ var : 2 } ) See example directory for an implementation, it also works in dev and test environments.","ref":"readme.html#testing-your-bridge","title":"Overview - Testing your bridge","type":"extras"},{"doc":"mix deps.get &amp;&amp; mix test","ref":"readme.html#development","title":"Overview - Development","type":"extras"},{"doc":"The package can be installed by adding bridge_ex to your list of dependencies in mix.exs : def deps do [ { :bridge_ex , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Copyright (c) 2020 Prima.it This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]